#include <stdio.h>
#include <math.h>
#include <imsls.h>

int main(){
    int n_obs       = 24;
    int n_locations = 1;
    int n_factors   = 3;
    int n_levels[4] ={3, 2, 2, 2}; 
    int model[]={
            1, 1, 1, 1, 1,
            1, 2, 1, 1, 1,
            1, 1, 1, 1, 2,
            1, 2, 1, 1, 2,
            1, 1, 1, 2, 1,
            1, 2, 1, 2, 1,
            1, 1, 1, 2, 2,
            1, 2, 1, 2, 2,
            1, 1, 2, 1, 1,
            1, 2, 2, 1, 1,
            1, 1, 2, 1, 2,
            1, 2, 2, 1, 2,
            1, 1, 2, 2, 1,
            1, 2, 2, 2, 1,
            1, 1, 2, 2, 2,
            1, 2, 2, 2, 2,
            1, 1, 3, 1, 1,
            1, 2, 3, 1, 1,
            1, 1, 3, 1, 2,
            1, 2, 3, 1, 2,
            1, 1, 3, 2, 1,
            1, 2, 3, 2, 1,
            1, 1, 3, 2, 2,
            1, 2, 3, 2, 2
    };
    float y[] ={
            4.42725419998168950, 2.98526261840015650, 
            2.12795543670654300, 4.36357164382934570,
            2.55254390835762020, 2.78596709668636320,
            1.21479606628417970, 2.68143519759178160,
            2.47588264942169190, 4.69543695449829100,
            5.01306104660034180, 3.01919978857040410,
            4.73502767086029050, 0.00000000000000000,
            0.00000000000000000, 5.05780076980590820,
            5.01421167794615030, 3.61517095565795900,
            4.11972457170486450, 4.71947982907295230,
            6.51671624183654790, 4.22036057710647580,
            4.73365202546119690, 4.68545144796371460
    };
        
   int page_width = 132;
   int model_order;
   int i, n_subscripts, n_anova_table;
   char **aov_labels;
   char *col_labels[] = {" ", "ID", "df", "SS", 
                         "MS", "F-Test", "P-Value"};
   float *anova_table;

   /* Compute number of rows in the anova table. */
   model_order = n_subscripts = n_factors;
   n_anova_table = 3;
   for (i=1; i <= model_order; i++){
       n_anova_table += imsls_d_binomial_coefficient(n_subscripts, i);
   }
   
   /* Set missing observations. */
   y[13] = imsls_d_machine(6);
   y[14] = imsls_d_machine(6); 

   anova_table = imsls_f_rcbd_factorial(n_obs, n_locations, n_factors,
                                        n_levels, model, y,
                                        IMSLS_ANOVA_ROW_LABELS, &aov_labels,
                                        0) ;
   imsls_page(IMSLS_SET_PAGE_WIDTH, &page_width);
   /*
    * Print ANOVA table.
    */
  imsls_f_write_matrix("   *** ANALYSIS OF VARIANCE TABLE ***", 
                       10, 6, anova_table, 
                       IMSLS_ROW_LABELS, aov_labels, 
                       IMSLS_COL_LABELS, col_labels, 
                       IMSLS_WRITE_FORMAT, "%3.0f%3.0f%8.2f%7.2f%7.2f%7.3f",
                       0);
}
